------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008, 2009 Vadim Godunko <vgodunko@gmail.com>                --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt_Ada.Internals.Object_Registry;
pragma Elaborate (Qt_Ada.Internals.Object_Registry);

package body Qt_Ada.Internals.Objects.Layout_Proxies is

   procedure addItem_0_virtual
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Item : not null access Qt4.Layout_Items.Impl.Thin.QLayoutItem);
      pragma Import (C, addItem_0_virtual,
                     "__Qt4Ada_QLayout_addItem_0_virtual");

   function count_0_virtual
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Q_Integer;
      pragma Import (C, count_0_virtual,
                     "__Qt4Ada_QLayout_count_0_virtual");

   function indexOf_0_virtual
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Widget : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Q_Integer;
      pragma Import (C, indexOf_0_virtual,
                     "__Qt4Ada_QLayout_indexOf_0_virtual");

   function isEmpty_0_virtual
    (Self : not null access Qt4.Layout_Items.Impl.Thin.QLayoutItem)
       return Qt4.bool;
      pragma Import (C, isEmpty_0_virtual,
                     "__Qt4Ada_QLayoutItem_isEmpty_0_virtual");

   procedure minimumSize_0_virtual
    (Self : not null access Qt4.Layout_Items.Impl.Thin.QLayoutItem;
     Returns : not null access Qt4.Sizes.Internals.QSize);
      pragma Import (C, minimumSize_0_virtual,
                     "__Qt4Ada_QLayoutItem_minimumSize_0_virtual");

   procedure maximumSize_0_virtual
    (Self : not null access Qt4.Layout_Items.Impl.Thin.QLayoutItem;
     Returns : not null access Qt4.Sizes.Internals.QSize);
      pragma Import (C, maximumSize_0_virtual,
                     "__Qt4Ada_QLayoutItem_maximumSize_0_virtual");

   function hasHeightForWidth_0_virtual
    (Self : not null access Qt4.Layout_Items.Impl.Thin.QLayoutItem)
       return Qt4.bool;
      pragma Import (C, hasHeightForWidth_0_virtual,
                     "__Qt4Ada_QLayoutItem_hasHeightForWidth_0_virtual");

   function heightForWidth_0_virtual
    (Self : not null access Qt4.Layout_Items.Impl.Thin.QLayoutItem;
     W : Qt4.Q_Integer)
       return Qt4.Q_Integer;
      pragma Import (C, heightForWidth_0_virtual,
                     "__Qt4Ada_QLayoutItem_heightForWidth_0_virtual");

   procedure invalidate_0_virtual
    (Self : not null access Qt4.Layout_Items.Impl.Thin.QLayoutItem);
      pragma Import (C, invalidate_0_virtual,
                     "__Qt4Ada_QLayoutItem_invalidate_0_virtual");

   function layout_0_virtual
    (Self : not null access Qt4.Layout_Items.Impl.Thin.QLayoutItem)
       return not null access Qt_Ada.Internals.Objects.QObject;
      pragma Import (C, layout_0_virtual,
                     "__Qt4Ada_QLayoutItem_layout_0_virtual");

   function minimumHeightForWidth_0_virtual
    (Self : not null access Qt4.Layout_Items.Impl.Thin.QLayoutItem;
     W : Qt4.Q_Integer)
       return Qt4.Q_Integer;
      pragma Import (C, minimumHeightForWidth_0_virtual,
                     "__Qt4Ada_QLayoutItem_minimumHeightForWidth_0_virtual");

   procedure sizeHint_0_virtual
    (Self : not null access Qt4.Layout_Items.Impl.Thin.QLayoutItem;
     Returns : not null access Qt4.Sizes.Internals.QSize);
      pragma Import (C, sizeHint_0_virtual,
                     "__Qt4Ada_QLayoutItem_sizeHint_0_virtual");

   function widget_0_virtual
    (Self : not null access Qt4.Layout_Items.Impl.Thin.QLayoutItem)
       return not null access Qt_Ada.Internals.Objects.QObject;
      pragma Import (C, widget_0_virtual,
                     "__Qt4Ada_QLayoutItem_widget_0_virtual");

   function Create
    (Object : not null Qt_Ada.Internals.Objects.QObject_Access)
       return not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;

   function expandingDirections_virtual
    (This : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Orientations;
   pragma Import (C,
                  expandingDirections_virtual,
                  "__Qt4Ada_QLayout_expandingDirections_virtual");

   --------------------------
   -- Expanding_Directions --
   --------------------------

   function Expanding_Directions
    (Self : not null access constant Q_Layout_Proxy)
       return Qt4.Orientations
   is
   begin
      return expandingDirections_virtual (Self.QObject_View);
   end Expanding_Directions;

   ----------------------
   -- QLayoutItem_View --
   ----------------------

--   overriding
   function QLayoutItem_View
    (Self : not null access constant Q_Layout_Proxy)
       return not null access Qt4.Layout_Items.Impl.Thin.QLayoutItem
   is
   begin
      raise Program_Error;
      return new Qt4.Layout_Items.Impl.Thin.QLayoutItem;
   end QLayoutItem_View;

   pragma Style_Checks ("N");

   --------------
   -- Add_Item --
   --------------

   procedure Add_Item
    (Self : not null access Q_Layout_Proxy;
     Item : not null access Qt4.Layout_Items.Q_Layout_Item'Class)
   is
   begin
      addItem_0_virtual
       (Q_Layout_Proxy'Class (Self.all).QObject_View,
        Qt4.Layout_Items.Impl.Q_Layout_Item_Impl_Base'Class (Item.all).QLayoutItem_View);
   end Add_Item;

   -----------
   -- Count --
   -----------

   function Count
    (Self : not null access constant Q_Layout_Proxy)
       return Qt4.Q_Integer
   is
   begin
      return
        count_0_virtual
         (Q_Layout_Proxy'Class (Self.all).QObject_View);
   end Count;

   --------------
   -- Index_Of --
   --------------

   function Index_Of
    (Self : not null access constant Q_Layout_Proxy;
     Widget : not null access Qt4.Widgets.Q_Widget'Class)
       return Qt4.Q_Integer
   is
   begin
      return
        indexOf_0_virtual
         (Q_Layout_Proxy'Class (Self.all).QObject_View,
          Widget.QObject_View);
   end Index_Of;

   --------------
   -- Is_Empty --
   --------------

   function Is_Empty
    (Self : not null access constant Q_Layout_Proxy)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (isEmpty_0_virtual
           (Q_Layout_Proxy'Class (Self.all).QLayoutItem_View));
   end Is_Empty;

   ------------------
   -- Minimum_Size --
   ------------------

   function Minimum_Size
    (Self : not null access constant Q_Layout_Proxy)
       return Qt4.Sizes.Q_Size
   is
      Returns : Qt4.Sizes.Q_Size;

   begin
      minimumSize_0_virtual
       (Q_Layout_Proxy'Class (Self.all).QLayoutItem_View,
        Qt4.Sizes.Internals.QSize_View (Returns));

      return Returns;
   end Minimum_Size;

   ------------------
   -- Maximum_Size --
   ------------------

   function Maximum_Size
    (Self : not null access constant Q_Layout_Proxy)
       return Qt4.Sizes.Q_Size
   is
      Returns : Qt4.Sizes.Q_Size;

   begin
      maximumSize_0_virtual
       (Q_Layout_Proxy'Class (Self.all).QLayoutItem_View,
        Qt4.Sizes.Internals.QSize_View (Returns));

      return Returns;
   end Maximum_Size;

   --------------------------
   -- Has_Height_For_Width --
   --------------------------

   function Has_Height_For_Width
    (Self : not null access constant Q_Layout_Proxy)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (hasHeightForWidth_0_virtual
           (Q_Layout_Proxy'Class (Self.all).QLayoutItem_View));
   end Has_Height_For_Width;

   ----------------------
   -- Height_For_Width --
   ----------------------

   function Height_For_Width
    (Self : not null access constant Q_Layout_Proxy;
     W : Qt4.Q_Integer)
       return Qt4.Q_Integer
   is
   begin
      return
        heightForWidth_0_virtual
         (Q_Layout_Proxy'Class (Self.all).QLayoutItem_View,
          W);
   end Height_For_Width;

   ----------------
   -- Invalidate --
   ----------------

   procedure Invalidate
    (Self : not null access Q_Layout_Proxy)
   is
   begin
      invalidate_0_virtual
       (Q_Layout_Proxy'Class (Self.all).QLayoutItem_View);
   end Invalidate;

   ------------
   -- Layout --
   ------------

   function Layout
    (Self : not null access Q_Layout_Proxy)
       return not null access Qt4.Layouts.Q_Layout'Class
   is
   begin
      return
        Qt4.Layouts.Q_Layout'Class
         (Qt_Ada.Internals.Object_Registry.To_Q_Object
           (layout_0_virtual
             (Q_Layout_Proxy'Class (Self.all).QLayoutItem_View)).all)'Access;
   end Layout;

   ------------------------------
   -- Minimum_Height_For_Width --
   ------------------------------

   function Minimum_Height_For_Width
    (Self : not null access constant Q_Layout_Proxy;
     W : Qt4.Q_Integer)
       return Qt4.Q_Integer
   is
   begin
      return
        minimumHeightForWidth_0_virtual
         (Q_Layout_Proxy'Class (Self.all).QLayoutItem_View,
          W);
   end Minimum_Height_For_Width;

   ---------------
   -- Size_Hint --
   ---------------

   function Size_Hint
    (Self : not null access constant Q_Layout_Proxy)
       return Qt4.Sizes.Q_Size
   is
      Returns : Qt4.Sizes.Q_Size;

   begin
      sizeHint_0_virtual
       (Q_Layout_Proxy'Class (Self.all).QLayoutItem_View,
        Qt4.Sizes.Internals.QSize_View (Returns));

      return Returns;
   end Size_Hint;

   ------------
   -- Widget --
   ------------

   function Widget
    (Self : not null access Q_Layout_Proxy)
       return not null access Qt4.Widgets.Q_Widget'Class
   is
   begin
      return
        Qt4.Widgets.Q_Widget'Class
         (Qt_Ada.Internals.Object_Registry.To_Q_Object
           (widget_0_virtual
             (Q_Layout_Proxy'Class (Self.all).QLayoutItem_View)).all)'Access;
   end Widget;

   type Q_Layout_Proxy_Access is
     access all Q_Layout_Proxy'Class;

   ------------
   -- Create --
   ------------

   function Create
    (Object : not null Qt_Ada.Internals.Objects.QObject_Access)
       return not null Qt_Ada.Internals.Objects.Q_Object_Base_Access
   is
      Self : constant not null Q_Layout_Proxy_Access
        := new Q_Layout_Proxy;

   begin
      Qt_Ada.Internals.Objects.Initialize (Self, Object);

      return Qt_Ada.Internals.Objects.Q_Object_Base_Access (Self);
   end Create;

begin
   Qt_Ada.Internals.Object_Registry.Register_Proxy
    ("QLayout", Create'Access);
end Qt_Ada.Internals.Objects.Layout_Proxies;
